% popsamp.m

function [ sample ] = popsamp(data,weights,factor)

N      = sum(round(weights./factor));
sample = zeros(N,min(size(data)));

i = 1;
j = 1;

while i <= length(data),

   tmp = round(weights(i,1)./factor);
   
   sample(j:j+tmp-1,:) = repmat(data(i,:),tmp,1);
   
   j = j + tmp;
   i = i + 1;
   
end