% vfiosavings.m

voe = Wo(1,z0idx) * ones(na,N,T);
vou = UoA(1,1)    * ones(na,T);

tvoe    = zeros(na,N,T);       tvou    = zeros(na,1);
decisoe = zeros(na,N,T);       decisou = zeros(na,1);
MMoe    = zeros(na,N,T);       MMou    = zeros(na,1);
iter    = 0;                   metric  = 10;                  nVFI = 5;

drule = na.*[0:na-1]';                                     % This is used to translate the decision rule later
XX    = kron(na*[0:N-1]',ones(na,1));                      % This is used later
splitosum = sum(splito,2);                                 % This is used later

while metric > 0.5
  
  if metric < 8,   nVFI = 20;   end

  for itau = 1 : T
   voeptmp  = voe(:,:,min(itau+1,T));
   for iz = 1 : N
    if splito(itau,iz) < 1
     RRoetmp1 = RRoe(:,(iz-1)*na+1:iz*na,itau);
     [ tvoe(:,iz,itau) , decisoe(:,iz,itau) ] = max(RRoetmp1 + repmat(betta * (1-chi) * ((1-delta)*voeptmp*P(iz,:)' + ...
                                                    delta*vou(idxSP(:,min(itau+1,T)),1)) + betta * chi * vr,1,na));
     idxdec = drule + decisoe(:,iz,itau);
     MMoe(:,iz,itau) = RRoetmp1(idxdec);
    else
     tvoe(:,iz,itau) = vou(idxSP(:,itau),1);
     MMoe(:,iz,itau) = -10;
    end
   end
  end
  [ tvou(:,1) , decisou(:,1) ] = max(RRou + repmat(betta*(1-chi)*vou(:,1) + betta*chi*vr,1,na));
  idxdec = drule + decisou(:,1);
  MMou(:,1) = RRou(idxdec);
  
  decisoe(decisoe == 0) = 1;
  
  vvoe  = tvoe;              vvou  = tvou;
  tvvoe = zeros(na,N,T);     tvvou = zeros(na,1);
  CVr   = betta * chi * repmat(vr,1,N);
  
  for iVFI = 1 : nVFI
    for itau = 1 : T      
      CV = (1-delta) * vvoe(:,:,min(itau+1,T))*P' + repmat(delta * vvou(idxSP(:,min(itau+1,T)),1),1,N);
      decisoetmp = decisoe(:,:,itau);
      CVvec = CV(:);
      CVx = CVvec(XX + decisoetmp(:));
      tmp = MMoe(:,:,itau) + betta * (1-chi) * reshape(CVx,na,N) + CVr;
      tmp(:,1:splitosum(itau)) = repmat(vvou(idxSP(:,itau),1),1,splitosum(itau));
      tvvoe(:,:,itau) = tmp;
    end    
    tvvou(:,1) = MMou(:,1) + betta * (1-chi) * vvou(decisou(:,1),1) + betta * chi * vr(decisou(:,1),1);
    vvoe = tvvoe;     vvou = tvvou;
  end

  tvoe = vvoe;
  tvou = vvou;
  
  metric = max( max(max(max(abs(tvoe-voe)))) , max(abs(tvou-vou)) );
  %if mod(iter+1,5) == 0,   fprintf('   Iter = %2.0d     Metric = %6.4f\n',iter+1,metric);   end

  voe = tvoe;
  vou = tvou;
  iter = iter + 1;
  
end

fprintf('  O-1')

tadecoe = zeros(na,N,T);   tvoe = zeros(na,N,T);   nafine = na/2;
tadecou = zeros(na,1);     tvou = zeros(na,1);

for itau = 1 : T
  for iz = 1 : N

    if (iz == 1) && (itau == 1)
      
      A = agrid(max(decisou(:,1) - 1,1));              % Old and unemployed A
      D = agrid(min(decisou(:,1) + 1,na));

      agridf = zeros(nafine,na);
      for ia = 1 : na
        agridf(:,ia) = linspace(A(ia),D(ia),nafine)';
      end
      
      c  = (1+r)*repmat(agrid',nafine,1) + bo - agridf;
      MM = 1 - 1./(max(c,1e-12));
      CV = interp1q(agrid,betta*(1-chi)*vou(:,1) + betta*chi*vr,agridf(:));

      [tvou(:,1),idx] = max(MM + reshape(CV,nafine,na));
      for ia = 1 : na
        tadecou(ia,1) = agridf(idx(ia),ia);
      end
      
    end
    
    if splito(itau,iz) < 1
    
      A = agrid(max(decisoe(:,iz,itau) - 1,1));            % Old and employed
      D = agrid(min(decisoe(:,iz,itau) + 1,na));

      agridf = zeros(nafine,na);
      for ia = 1 : na
        agridf(:,ia) = linspace(A(ia),D(ia),nafine)';
      end

      c  = (1+r)*repmat(agrid',nafine,1) + wo(itau,iz) + (-1000000)*splito(itau,iz) - agridf;
      MM = 1 - 1./(max(c,1e-12));  
      CV = interp1q(agrid,betta*(1-chi)*((1-delta) * vvoe(:,:,min(itau+1,T)) + delta * vvou(idxSP(:,min(itau+1,T)),1)) + ...
                          betta*chi*vr,agridf(:))*P(iz,:)';

      [tvoe(:,iz,itau),idx] = max(MM + reshape(CV,nafine,na));

      for ia = 1 : na
        tadecoe(ia,iz,itau) = agridf(idx(ia),ia);
      end
      
    else
      
      tvoe(:,iz,itau)    = tvou(idxSP(:,itau,1));
      tadecoe(:,iz,itau) = tadecou(idxSP(:,itau),1);
      
    end
        
  end
end

adecoe = tadecoe;     voe = tvoe;
adecou = tadecou;     vou = tvou;

fprintf('-2')

clear A D CV CVvec CVx decisoetmp RRoetmp RRoetmp1 RRoe RRoutmp RRou CVr decisoe decisouA decisouB iVFI iter idx ...
      itau iz MM MMoe MMou nafine ia idxdec itau tadecoe tadecou tvoe tvou tdecisoe tdecisou voeptmp tmp splitosum ...
      tvvoe tvvou vvr vvou metric c agridf