% vfirsavings.m

vr = -600 * ones(na,1);

tvr    = zeros(na,1);   decisr  = zeros(na,1);   iter = 0;
metric = 10;            nVFI    = 50;            drule = na.*[0:na-1]';

while metric > 0.1
  
  [ tvr(:,1) , decisr(:,1) ] = max(RRr + repmat(betta*(1-iota)*vr,1,na));
  idxdec = drule + decisr;
  MMr = RRr(idxdec);   vvr = tvr;

  for iVFI = 1 : nVFI
    tvvr = MMr + betta * (1-iota) * vvr(decisr,1);
    vvr  = tvvr;
  end

  tvr  = vvr;   metric = max(abs(tvr-vr));
  vr   = tvr;
  iter = iter + 1;
  
end

nafine = na/2;   tadecr = zeros(na,1);   tvr = zeros(na,1);

A = agrid(max(decisr - 1,1));
D = agrid(min(decisr + 1,na));

agridf = zeros(nafine,na);
for ia = 1 : na
  agridf(:,ia) = [ linspace(A(ia),D(ia),nafine-1)' ; agrid(decisr(ia)) ];
end

c  = (1+r)*repmat(agrid',nafine,1) + br - agridf;
MM = 1 - 1./(max(c,1e-12));
CV = interp1q(agrid,vr,agridf(:));

[tvr(:,1),idx] = max(MM + betta*(1-iota)*reshape(CV,nafine,na));
for ia = 1 : na
  tadecr(ia,1) = agridf(idx(ia),ia);
end

adecr = tadecr;     vr = tvr;

fprintf('\n   R')

clear A D CV decisr RRr iVFI iter idx MMr MM nafine ia idxdec itau tadecr tvr tdecisr tvvr metric c agridf