% vfiysavings.m

vye = W(1,z0idx) * ones(na,N,T);
vyu = U(1,1)     * ones(na,1);

tvye     = zeros(na,N,T);     tvyu     = zeros(na,1);
decisye  = zeros(na,N,T);     decisyu  = zeros(na,1);
MMe      = zeros(na,N,T);     MMu      = zeros(na,1);
iter     = 0;                 metric   = 10;                   nVFI = 3;

splitsum = sum(split,2);

while metric > 0.5
  
  if metric < 8,   nVFI = 20;   end

  for itau = 1 : T
    vyeptmp  = vye(:,:,min(itau+1,T));
    voeptmp = voe(:,:,min(itau+1,T));
    for iz = 1 : N
      if split(itau,iz) < 1
        RRyetmp1 = RRye(:,(iz-1)*na+1:iz*na,itau);
        [ tvye(:,iz,itau) , decisye(:,iz,itau) ] = max(RRyetmp1 + repmat(betta * ((1-gamma)*((1-delta)*vyeptmp*P(iz,:)' + ...
           delta*vyu(idxSP(:,min(itau+1,T)),1)) + gamma*((1-delta)*voeptmp*P(iz,:)' + delta*vou(idxSP(:,min(itau+1,T)),1))),1,na));
        idxdec = drule + decisye(:,iz,itau);
        MMe(:,iz,itau) = RRyetmp1(idxdec);
      else
        tvye(:,iz,itau) = vyu(idxSP(:,itau),1);
        MMe(:,iz,itau) = -10;
      end
    end
  end
  [ tvyu(:,1) , decisyu(:,1) ] = max(RRyu + repmat(betta * ((1-gamma)*(q*theta*vye(:,z0idx,1) + ...
                                    (1-q*theta)*vyu(:,1)) + gamma*vou(:,1)),1,na));
  idxdec = drule + decisyu(:,1);
  MMu(:,1) = RRyu(idxdec);
  
  decisye(decisye == 0) = 1;
  
  vvye = tvye;     vvyu  = tvyu;     tvvye = zeros(na,N,T);     tvvyu = zeros(na,1);

  for iVFI = 1 : nVFI    
    for itau = 1 : T
      CV = (1-gamma)*((1-delta) * vvye(:,:,min(itau+1,T))*P' + repmat(delta * vvyu(idxSP(:,min(itau+1,T)),1),1,N)) + ...
              gamma *((1-delta) * voe(:,:,min(itau+1,T))*P'  + repmat(delta * vou(idxSP(:,min(itau+1,T)),1),1,N));
      decisyetmp = decisye(:,:,itau);
      CVvec = CV(:);
      CVx = CVvec(XX + decisyetmp(:));
      tmp = MMe(:,:,itau) + betta * reshape(CVx,na,N);
      tmp(:,1:splitsum(itau)) = repmat(vvyu(:,1),1,splitsum(itau));                  
      tvvye(:,:,itau) = tmp;
    end
    tvvyu(:,1) = MMu(:,1) + betta * ((1-gamma)*(q*theta*vvye(decisyu(:,1),z0idx,1) + ...
                (1-q*theta)*vvyu(decisyu(:,1),1)) + gamma * vou(decisyu(:,1),1));
    vvye = tvvye;     vvyu = tvvyu;
  end

  tvye = vvye;     tvyu = vvyu;
  
  metric = max( max(max(max(abs(tvye-vye)))) , max(abs(tvyu-vyu)) );
  %if mod(iter+1,5) == 0,   fprintf('   Iter = %2.0d     Metric = %6.4f\n',iter+1,metric);   end

  vye = tvye;
  vyu = tvyu;
  iter = iter + 1;
  
end

fprintf('  Y-1')

tadecye = zeros(na,N,T);   tvye = zeros(na,N,T);   nafine = na/2;
tadecyu = zeros(na,1);     tvyu = zeros(na,1);

for itau = 1 : T
  for iz = 1 : N
    
    if (iz == 1) && (itau == 1)
      
      A = agrid(max(decisyu(:,1) - 1,1));                  % Young and unemployed
      D = agrid(min(decisyu(:,1) + 1,na));

      agridf = zeros(nafine,na);
      for ia = 1 : na
        agridf(:,ia) = linspace(A(ia),D(ia),nafine)';
      end
      
      c  = (1+r)*repmat(agrid',nafine,1) + b + beqy - agridf;
      MM = 1 - 1./(max(c,1e-12));
      
      CV = interp1q(agrid,(1-gamma)*(q*theta*vye(:,z0idx,1) + (1-q*theta)*vyu(:,1)) + gamma*vou(:,1),agridf(:));
           
      [tvyu(:,1),idx] = max(MM + betta*reshape(CV,nafine,na));
      for ia = 1 : na
        tadecyu(ia,1) = agridf(idx(ia),ia);
      end
      
    end
    
    if split(itau,iz) < 1
    
      A = agrid(max(decisye(:,iz,itau) - 1,1));            % Young and employed
      D = agrid(min(decisye(:,iz,itau) + 1,na));

      agridf = zeros(nafine,na);
      for ia = 1 : na
        agridf(:,ia) = linspace(A(ia),D(ia),nafine)';
      end
      
      c  = (1+r)*repmat(agrid',nafine,1) + w(itau,iz) + beqy + (-1000000)*split(itau,iz) - agridf;
      MM = 1 - 1./(max(c,1e-12));
      
      CV = interp1q(agrid,(1-gamma)*((1-delta)*vye(:,:,min(itau+1,T))*P(iz,:)' + delta*vyu(idxSP(:,min(itau+1,T)),1)) + ...
           gamma*((1-delta)*voe(:,:,min(itau+1,T))*P(iz,:)' + delta*vou(idxSP(:,min(itau+1,T)),1)),agridf(:));
      
      [tvye(:,iz,itau),idx] = max(MM + betta*reshape(CV,nafine,na));

      for ia = 1 : na
        tadecye(ia,iz,itau) = agridf(idx(ia),ia);
      end
      
    else
      
      tvye(:,iz,itau)    = tvyu(:,1);
      tadecye(:,iz,itau) = tadecyu(:,1);
      
    end
    
  end
end

adecye = tadecye;      vye = tvye;
adecyu = tadecyu;      vyu = tvyu;

fprintf('-2 ')

clear A D CV CVvec CVx RRyetmp RRyetmp1 RRye RRyu decisye decisyu decisyetmp iVFI iter idx itau iz MM MMe MMu nafine ...
       drule ia idxdec itau tadecye tadecyu tdecisyu tdecisye vyeptmp tmp XX splitsum tvvye tvvyu vvoe voeptmp vvye ...
      vvyu tvye tvyu nVFI metric c agridf